;===========================================================================
;** Calculates the number of assigned elements in an array.
;** MODIFIED: 4/18/93 7:36 PM GORD0
;---------------------------------------------------------------------------
Proc ARRAY.NUMASSIGNED(ARRAYELEM)
  Private ARRAYELEM,A.SIZE,X,N.ASSIGNED
  N.ASSIGNED=0
  Switch
    Case Type(ARRAYELEM)="AY":  ;Fixed Array
      A.SIZE=ArraySize(ARRAYELEM)
      For X From 1 To A.SIZE
        If IsAssigned(ARRAYELEM[x]) Then
          N.ASSIGNED=N.ASSIGNED+1
        EndIf
      EndFor
      
    Case Type(ARRAYELEM)="DY":  ;Dynamic Array
      ForEach X In ARRAYELEM
        If IsAssigned(ARRAYELEM[x]) Then
          N.ASSIGNED=N.ASSIGNED+1
        EndIf
      EndForEach
  EndSwitch
  Return N.ASSIGNED
EndProc
;WriteLib LIBNAME ARRAY.NUMASSIGNED
;Release Procs ARRAY.NUMASSIGNED



;===========================================================================
;** Word wraps a string to an array.
;** MODIFIED: 4/6/94 9:34 PM GORD0
;---------------------------------------------------------------------------
Proc Closed ARRAY.WORDWRAP(ARRAYNAME,TEXTSTRING,LINE.LEN)
  UseVars AutoLib,ErrorProc,DNI
  
  SUB.STRING="" NEXT.SUB.STRING=""
  C.LINE=1
  TEXT.LEN=Len(TEXTSTRING)
  For X From 1 To TEXT.LEN
    SUB.STRING=SUB.STRING+Substr(TEXTSTRING,X,1)
    
    If Substr(TEXTSTRING,X,1)="\n" Then                   ;New Line
      ARRAYNAME[C.LINE]=Substr(SUB.STRING,1,Len(SUB.STRING)-1)+Spaces(LINE.LEN-Len(Substr(SUB.STRING,1,Len(SUB.STRING)-1)))
      SUB.STRING=""
      C.LINE=C.LINE+1
    EndIf
    
    If Len(SUB.STRING)=LINE.LEN Then
      Switch
        Case Substr(TEXTSTRING,X,1)=" ":                   ;BETWEEN WORDS
          ARRAYNAME[C.LINE]=SUB.STRING+Spaces(LINE.LEN-Len(SUB.STRING))
          SUB.STRING=""
          C.LINE=C.LINE+1
          
        Case X<TEXT.LEN And Substr(TEXTSTRING,X+1,1)=" ":  ;END OF CURRENT WORD
          ARRAYNAME[C.LINE]=SUB.STRING+Spaces(LINE.LEN-Len(SUB.STRING))
          SUB.STRING=""
          C.LINE=C.LINE+1
          X=X+1
          
        Otherwise:                                         ;MIDDLE OF WORD, WRAP
          FOUND.L=False
          For Z From LINE.LEN To 1 Step -1
            If Substr(SUB.STRING,Z,1)=" " Then             ;FOUND BETWEEN OF WORDS
              ARRAYNAME[C.LINE]=Substr(SUB.STRING,1,Z-1)+Spaces(LINE.LEN-Len(Substr(SUB.STRING,1,Z-1)))
              SUB.STRING=Substr(SUB.STRING,Z+1,LINE.LEN-Z+1)
              C.LINE=C.LINE+1
              FOUND.L=True
              QuitLoop
            EndIf
          EndFor
          If Not FOUND.L Then
            ARRAYNAME[C.LINE]=SUB.STRING+Spaces(LINE.LEN-Len(SUB.STRING))
            SUB.STRING=""
            C.LINE=C.LINE+1
          EndIf
      EndSwitch
    EndIf
  EndFor
  ARRAYNAME[C.LINE]=SUB.STRING+Spaces(LINE.LEN-Len(SUB.STRING))    ;ASSIGNE WHAT IS LEFT OF THE STRING.
  
  Return ARRAY.NUMASSIGNED(ARRAYNAME)
EndProc
;WriteLib LIBNAME ARRAY.WORDWRAP
;Release Procs ARRAY.WORDWRAP


;===========================================================================
;** DIALOG BOX EVENT HANDLER
;** ORIGINAL: 9/6/93 4:35 PM GORD0
;** MODIFIED: 3/13/94 1:58 PM GORD0
;---------------------------------------------------------------------------
Proc MESSAGE.BOX.HANDLER(TRIGGERTYPE,TAGVALUE,EVENTVALUE,ELEMENTVALUE)
  Private TRIGGERTYPE,TAGVALUE,EVENTVALUE,ELEMENTVALUE,OK.L,X,BUTTONSTATUS,Y
  OK.L=True
  
  
  ;--Handle Idle Events, (AutoSelect)
  If TRIGGERTYPE="EVENT" And EVENTVALUE["TYPE"]="IDLE" Then
    IF NOT ISASSIGNED(DNI["DIALOG.IDLE"]) THEN
      DNI["DIALOG.IDLE"]=Ticks()
      DNI["DIALOG.AUTOSELECTINSECS"]=120
    ENDIF
    If ((Ticks()-DNI["DIALOG.IDLE"])/1000)>DNI["DIALOG.AUTOSELECTINSECS"] And DNI["DIALOG.AUTOSELECTINSECS"]>0 Then
      If CharWaiting() Then
        DNI["DIALOG.IDLE"]=Ticks()  
        Return True
      EndIf
      PUSHKEYS "ENTER"
      Return True
    EndIf
    Return True
  EndIf
  
  ;--SET DEFAULT BUTTON
  If TRIGGERTYPE="OPEN" Then
    Switch
      Case BUTTONSTATUS=1:  SelectControl "B1"
      Case BUTTONSTATUS=2:  SelectControl "B2"
      Case BUTTONSTATUS=3:  SelectControl "B3"
    EndSwitch
  EndIf
  
  DNI["DIALOG.IDLE"]=Ticks()
  RefreshDialog
  Return True
EndProc
;WriteLib LIBNAME MESSAGE.BOX.HANDLER
;Release Procs MESSAGE.BOX.HANDLER


;===========================================================================
;** Creates a Dialog Box, Asking a question.
;** ORIGINAL: 9/6/93 4:35 PM GORD0
;** MODIFIED: 5/16/94 3:19 AM GORD0
;---------------------------------------------------------------------------
Proc Closed MESSAGE.BOX(BOXTITLE,BOXTEXT,BUTTONTYPE)
  UseVars AutoLib,ErrorProc
  
  ;ButtonType= ButtonScheme+Icon+ButtonStatus
  ;
  ;Button Scheme                 Icon                 Button Status
  ;--------------------------------------------------------------------------
  ;0=OK                         0=(No Icon)           0=1st Button Default
  ;
  ;1=OK and Cancel              16=Stop               256=2nd Button Default
  ;
  ;2=Abort,Retry,and Ignore     32=Question           512=3rd Button Default
  ;
  ;3=Yes,No, and Cancel         48=Exclamation Mark
  ;
  ;4=Yes and No                 64=Information
  ;
  ;5=Retry and Cancel
  ;
  ;6=Edit,Delete and Overwrite
  ;--------------------------------------------------------------------------
  ;The Return value is an integer that indicates which button was clicked:
  ;1=OK  2=Cancel  3=Abort  4=Retry  5=Ignore  6=Yes  7=No  8=Edit 9=Delete  10=Replace
  
  
  ;--Set AutoSelect if Not assigned.
  If Not IsAssigned(DNI["DIALOG.AUTOSELECTINSECS"]) Then
    If Not IsAssigned(DNI) THEN
      Dynarray DNI[]
    Endif
    DNI["DIALOG.AUTOSELECTINSECS"]=120
  EndIf
  
  ;--Define ButtonType Out
  BUTTONSTATUS=1  ICON=1  BUTTONSCHEME=1
  If BUTTONTYPE>=512 Then   BUTTONSTATUS=3  BUTTONTYPE=BUTTONTYPE-512  
  EndIf
  If BUTTONTYPE>=256 Then   BUTTONSTATUS=2  BUTTONTYPE=BUTTONTYPE-256  
  EndIf
  If BUTTONTYPE>=64 Then    ICON=5          BUTTONTYPE=BUTTONTYPE-64   
  EndIf
  If BUTTONTYPE>=48 Then    ICON=4          BUTTONTYPE=BUTTONTYPE-48   
  EndIf
  If BUTTONTYPE>=32 Then    ICON=3          BUTTONTYPE=BUTTONTYPE-32   
  EndIf
  If BUTTONTYPE>=16 Then    ICON=2          BUTTONTYPE=BUTTONTYPE-16   
  EndIf
  If BUTTONTYPE>=6 Then     BUTTONSCHEME=7  BUTTONTYPE=BUTTONTYPE-6    
  EndIf
  If BUTTONTYPE>=5 Then     BUTTONSCHEME=6  BUTTONTYPE=BUTTONTYPE-5    
  EndIf
  If BUTTONTYPE>=4 Then     BUTTONSCHEME=5  BUTTONTYPE=BUTTONTYPE-4    
  EndIf
  If BUTTONTYPE>=3 Then     BUTTONSCHEME=4  BUTTONTYPE=BUTTONTYPE-3    
  EndIf
  If BUTTONTYPE>=2 Then     BUTTONSCHEME=3  BUTTONTYPE=BUTTONTYPE-2    
  EndIf
  If BUTTONTYPE>=1 Then     BUTTONSCHEME=2  BUTTONTYPE=BUTTONTYPE-1    
  EndIf
  
  ;--BUILD ICON
  Array ICONLN[8]
  ICONCOLOR=1    ;BLUE
  MESSAGECOLOR=0 ;BLACK
  Switch
    Case ICON=2: ;--Stop
      ICONLN[1]="Ŀ"
      ICONLN[2]=" ͻ "
      ICONLN[3]=" ͻ "
      ICONLN[4]=" ͼ "
      ICONLN[5]=""
      ICONCOLOR=132 ;BLINKING RED
    Case ICON=3: ;--Question Mark
      ICONLN[1]="Ŀ"
      ICONLN[2]=" ͻ "
      ICONLN[3]="  ɼ "
      ICONLN[4]="    "
      ICONLN[5]=""
      ICONCOLOR=1 ;BLUE
    Case ICON=4: ;--Exclamation Mark
      ICONLN[1]="Ŀ"
      ICONLN[2]="    "
      ICONLN[3]="    "
      ICONLN[4]="    "
      ICONLN[5]=""
      ICONCOLOR=4  ;RED
    Case ICON=5: ;--Information
      ICONLN[1]="Ŀ"
      ICONLN[2]="    "
      ICONLN[3]="    "
      ICONLN[4]="    "
      ICONLN[5]=""
      ICONCOLOR=142 ;BLINKING YELLOW
  EndSwitch
  
  
  ;--BUILD BUTTON INFO
  Array BL[3]
  DynArray BV[]
  BV["~O~K"]=1    BV["~C~ancel"]=2  BV["~A~bort"]=3   BV["~R~etry"]=4   BV["~I~gnore"]=5  
  BV["~Y~es"]=6   BV["~N~o"]=7      BV["~E~dit"]=8    BV["~D~elete"]=9  BV["~R~eplace"]=10
  BL[1]=""    BL[2]=""   BL[3]=""
  Switch
    Case BUTTONSCHEME=1: NBS=1  BL[1]="~O~K"
    Case BUTTONSCHEME=2: NBS=2  BL[1]="~O~K"     BL[2]="~C~ancel"
    Case BUTTONSCHEME=3: NBS=3  BL[1]="~A~bort"  BL[2]="~R~etry"   BL[3]="~I~gnore"
    Case BUTTONSCHEME=4: NBS=3  BL[1]="~Y~es"    BL[2]="~N~o"      BL[3]="~C~ancel"
    Case BUTTONSCHEME=5: NBS=2  BL[1]="~Y~es"    BL[2]="~N~o"
    Case BUTTONSCHEME=6: NBS=2  BL[1]="~R~etry"  BL[2]="~C~ancel"
    Case BUTTONSCHEME=7: NBS=3  BL[1]="~E~dit"   BL[2]="~D~elete"  BL[3]="~R~eplace"
  EndSwitch
  If BUTTONSTATUS>NBS Then BUTTONSTATUS=1
  EndIf
  
  
  ;--BUILD MESSAGE BOX LINES
  Array TEXTLN[5]
  For X From 1 To 5 TEXTLN[X]=""
  EndFor
  BOXTEXT=Substr(BOXTEXT,1,IIf(ICON=1,99,69))
  ARRAY.WORDWRAP(TEXTLN,BOXTEXT,IIf(ICON=1,33,25))
  
  Array MBL[5]
  MBL[1]="" MBL[2]="" MBL[3]="" MBL[4]="" MBL[5]=""
  If ICON=1 Then ;No Icon Was Requested
    MBL[1]=" Ŀ"
    MBL[2]="  "+TEXTLN[1]+Spaces(33-Len(TEXTLN[1]))+""
    MBL[3]="  "+TEXTLN[2]+Spaces(33-Len(TEXTLN[2]))+""
    MBL[4]="  "+TEXTLN[3]+Spaces(33-Len(TEXTLN[3]))+""
    MBL[5]=" "
  Else
    MBL[1]=" "+ICONLN[1]+" Ŀ"
    MBL[2]=" "+ICONLN[2]+"  "+TEXTLN[1]+Spaces(25-Len(TEXTLN[1]))+""
    MBL[3]=" "+ICONLN[3]+"  "+TEXTLN[2]+Spaces(25-Len(TEXTLN[2]))+""
    MBL[4]=" "+ICONLN[4]+"  "+TEXTLN[3]+Spaces(25-Len(TEXTLN[3]))+""
    MBL[5]=" "+ICONLN[5]+" "
  EndIf
  
  ;--DETERMIN THE BEST LOCATION FOR THE BOX TO BE DISPLAYED.
  If NImages()>0 Then
    SyncCursor
    If Row()>14 Then
      DROW=5
    Else
      DROW=15
    EndIf
    If Col()>40 Then
      DCOLUMN=3
    Else
      DCOLUMN=34
    EndIf
  Else
    DROW=6
    DCOLUMN=20
  EndIf
  
  ;--DETERMINE BOX STATUS
  Array BCS[2]
  Array BCE[2]
  If ICON=1 Then ;NO Icon Was Selected
    BCS[1]=1  BCE[1]=36    BCS[2]=1  BCE[2]=36
  Else
    BCS[1]=1  BCE[1]=7     BCS[2]=9  BCE[2]=36
  EndIf
  
  ;--GET COLOR SCHEME
  GetColors To NEWCOLORS
  CBOX=(Int(NEWCOLORS["1036"]/16))*16
  
  ;--BUILD MESSAGE DIALOG BOX
  BP="OK"
  BOXTITLE=BOXTITLE
  Switch
    Case NBS=3: ;--Three Buttons
      ShowDialog BOXTITLE
        Proc "MESSAGE.BOX.HANDLER" Trigger "ALL" Idle
        @DROW,DCOLUMN Height 10 Width 40
        @0,0 ??MBL[1] @1,0 ??MBL[2] @2,0 ??MBL[3] @3,0 ??MBL[4] @4,0 ??MBL[5]
        PaintCanvas Attribute CBOX+15  0,BCS[1],0,BCE[1]
        PaintCanvas Attribute CBOX+15  0,BCS[1],4,BCS[1]
        PaintCanvas Attribute CBOX     4,BCS[1]+1,4,BCE[1]
        PaintCanvas Attribute CBOX     0,BCE[1],4,BCE[1]
        PaintCanvas Attribute CBOX+ICONCOLOR  1,BCS[1]+1,3,BCE[1]-1  ;--TEXT COLOR OF ICON
        
        PaintCanvas Attribute CBOX     0,BCS[2],0,BCE[2]
        PaintCanvas Attribute CBOX     0,BCS[2],4,BCS[2]
        PaintCanvas Attribute CBOX+15  4,BCS[2]+1,4,BCE[2]
        PaintCanvas Attribute CBOX+15  0,BCE[2],4,BCE[2]
        PaintCanvas Attribute CBOX+MESSAGECOLOR   1,BCS[2]+1,3,BCE[2]-1  ;--TEXT COLOR OF MESSAGE
        
        PushButton @6,4  Width 10 BL[1] Ok Value BL[1] Tag "B1" To BP
        PushButton @6,14 Width 10 BL[2] Ok Value BL[2] Tag "B2" To BP
        PushButton @6,24 Width 10 BL[3] Ok Value BL[3] Tag "B3" To BP
      EndDialog
      
    Case NBS=2: ;--Two Buttons
      ShowDialog BOXTITLE
        Proc "MESSAGE.BOX.HANDLER" Trigger "ALL" Idle
        @DROW,DCOLUMN Height 10 Width 40
        @0,0 ??MBL[1] @1,0 ??MBL[2] @2,0 ??MBL[3] @3,0 ??MBL[4] @4,0 ??MBL[5]
        PaintCanvas Attribute CBOX+15  0,BCS[1],0,BCE[1]
        PaintCanvas Attribute CBOX+15  0,BCS[1],4,BCS[1]
        PaintCanvas Attribute CBOX     4,BCS[1]+1,4,BCE[1]
        PaintCanvas Attribute CBOX     0,BCE[1],4,BCE[1]
        PaintCanvas Attribute CBOX+ICONCOLOR   1,BCS[1]+1,3,BCE[1]-1  ;--TEXT COLOR OF ICON
        
        PaintCanvas Attribute CBOX     0,BCS[2],0,BCE[2]
        PaintCanvas Attribute CBOX     0,BCS[2],4,BCS[2]
        PaintCanvas Attribute CBOX+15  4,BCS[2]+1,4,BCE[2]
        PaintCanvas Attribute CBOX+15  0,BCE[2],4,BCE[2]
        PaintCanvas Attribute CBOX+MESSAGECOLOR  1,BCS[2]+1,3,BCE[2]-1  ;--TEXT COLOR OF MESSAGE
        
        PushButton @6,7  Width 10 BL[1] Ok Value BL[1] Tag "B1" To BP
        PushButton @6,21 Width 10 BL[2] Ok Value BL[2] Tag "B2" To BP
      EndDialog
      
    Case NBS=1: ;--One Button
      ShowDialog BOXTITLE
        Proc "MESSAGE.BOX.HANDLER" Trigger "ALL" Idle
        @DROW,DCOLUMN Height 10 Width 40
        @0,0 ??MBL[1] @1,0 ??MBL[2] @2,0 ??MBL[3] @3,0 ??MBL[4] @4,0 ??MBL[5]
        PaintCanvas Attribute CBOX+15  0,BCS[1],0,BCE[1]
        PaintCanvas Attribute CBOX+15  0,BCS[1],4,BCS[1]
        PaintCanvas Attribute CBOX     4,BCS[1]+1,4,BCE[1]
        PaintCanvas Attribute CBOX     0,BCE[1],4,BCE[1]
        PaintCanvas Attribute CBOX+ICONCOLOR   1,BCS[1]+1,3,BCE[1]-1  ;--TEXT COLOR OF ICON
        
        PaintCanvas Attribute CBOX     0,BCS[2],0,BCE[2]
        PaintCanvas Attribute CBOX     0,BCS[2],4,BCS[2]
        PaintCanvas Attribute CBOX+15  4,BCS[2]+1,4,BCE[2]
        PaintCanvas Attribute CBOX+15  0,BCE[2],4,BCE[2]
        PaintCanvas Attribute CBOX+MESSAGECOLOR   1,BCS[2]+1,3,BCE[2]-1  ;--TEXT COLOR OF MESSAGE
        PushButton @6,14 Width 10 BL[1] Ok Value BL[1] Tag "B1" To BP
      EndDialog
  EndSwitch
  Return BV[BP]
EndProc
;WriteLib LIBNAME MESSAGE.BOX
;Release Procs MESSAGE.BOX




;=======================================================================================
;* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
;=======================================================================================

;CALL  MESSAGE.BOX(BoxTitle,BoxText,ButtonType)  
;
;BoxTitle=   Dialog Box Title
;
;BoxText=    Message to be displayed in the Box. (Auto Wordwrap) 
;
;ButtonType= ButtonScheme+Icon+ButtonStatus
;
;Button Scheme                 Icon                 Button Status
;--------------------------------------------------------------------------
;0=OK                         0=(No Icon)           0=1st Button Default
;
;1=OK and Cancel              16=Stop               256=2nd Button Default
;
;2=Abort,Retry,and Ignore     32=Question           512=3rd Button Default
;
;3=Yes,No, and Cancel         48=Exclamation Mark
;
;4=Yes and No                 64=Information
;
;5=Retry and Cancel
;
;6=Edit,Delete and Overwrite
;--------------------------------------------------------------------------
;The Return value is an integer that indicates which button was clicked:
;1=OK  2=Cancel  3=Abort  4=Retry  5=Ignore  6=Yes  7=No  8=Edit 9=Delete  10=Replace

Answer=MESSAGE.BOX("Testing","This is a test Box, this line will word wrap!",64)
MESSAGE "Message.Box() Returned: "+Strval(Answer)
SLEEP 1000

Answer=MESSAGE.BOX("Testing","This is a test Box, this line will word wrap. But Just how much will it wrap at a time?",64)
MESSAGE "Message.Box() Returned: "+Strval(Answer)
SLEEP 1000

Answer=MESSAGE.BOX("Testing","This is a test Box, this line will word wrap. But Just how much will it wrap at a time?",0)
MESSAGE "Message.Box() Returned: "+Strval(Answer)
SLEEP 1000

Answer=MESSAGE.BOX("Key Violation","What do you wish to do?",294)
MESSAGE "Message.Box() Returned: "+Strval(Answer)
SLEEP 1000

Answer=MESSAGE.BOX("Drive Error","Drive A: is not Ready.",56)
MESSAGE "Message.Box() Returned: "+Strval(Answer)
SLEEP 1000

Answer=MESSAGE.BOX("DataNamics","Do you Like this?",36)
MESSAGE "Message.Box() Returned: "+Strval(Answer)
SLEEP 1000

Answer=MESSAGE.BOX("DataNamics","\n      Demo Over.",16)
MESSAGE "Message.Box() Returned: "+Strval(Answer)
SLEEP 1000






